/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha2 "knative.dev/eventing/pkg/apis/sources/v1alpha2"
)

// FakeApiServerSources implements ApiServerSourceInterface
type FakeApiServerSources struct {
	Fake *FakeSourcesV1alpha2
	ns   string
}

var apiserversourcesResource = schema.GroupVersionResource{Group: "sources.knative.dev", Version: "v1alpha2", Resource: "apiserversources"}

var apiserversourcesKind = schema.GroupVersionKind{Group: "sources.knative.dev", Version: "v1alpha2", Kind: "ApiServerSource"}

// Get takes name of the apiServerSource, and returns the corresponding apiServerSource object, and an error if there is any.
func (c *FakeApiServerSources) Get(name string, options v1.GetOptions) (result *v1alpha2.ApiServerSource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(apiserversourcesResource, c.ns, name), &v1alpha2.ApiServerSource{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.ApiServerSource), err
}

// List takes label and field selectors, and returns the list of ApiServerSources that match those selectors.
func (c *FakeApiServerSources) List(opts v1.ListOptions) (result *v1alpha2.ApiServerSourceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(apiserversourcesResource, apiserversourcesKind, c.ns, opts), &v1alpha2.ApiServerSourceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha2.ApiServerSourceList{ListMeta: obj.(*v1alpha2.ApiServerSourceList).ListMeta}
	for _, item := range obj.(*v1alpha2.ApiServerSourceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested apiServerSources.
func (c *FakeApiServerSources) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(apiserversourcesResource, c.ns, opts))

}

// Create takes the representation of a apiServerSource and creates it.  Returns the server's representation of the apiServerSource, and an error, if there is any.
func (c *FakeApiServerSources) Create(apiServerSource *v1alpha2.ApiServerSource) (result *v1alpha2.ApiServerSource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(apiserversourcesResource, c.ns, apiServerSource), &v1alpha2.ApiServerSource{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.ApiServerSource), err
}

// Update takes the representation of a apiServerSource and updates it. Returns the server's representation of the apiServerSource, and an error, if there is any.
func (c *FakeApiServerSources) Update(apiServerSource *v1alpha2.ApiServerSource) (result *v1alpha2.ApiServerSource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(apiserversourcesResource, c.ns, apiServerSource), &v1alpha2.ApiServerSource{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.ApiServerSource), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeApiServerSources) UpdateStatus(apiServerSource *v1alpha2.ApiServerSource) (*v1alpha2.ApiServerSource, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(apiserversourcesResource, "status", c.ns, apiServerSource), &v1alpha2.ApiServerSource{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.ApiServerSource), err
}

// Delete takes name of the apiServerSource and deletes it. Returns an error if one occurs.
func (c *FakeApiServerSources) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(apiserversourcesResource, c.ns, name), &v1alpha2.ApiServerSource{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeApiServerSources) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(apiserversourcesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha2.ApiServerSourceList{})
	return err
}

// Patch applies the patch and returns the patched apiServerSource.
func (c *FakeApiServerSources) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha2.ApiServerSource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(apiserversourcesResource, c.ns, name, pt, data, subresources...), &v1alpha2.ApiServerSource{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.ApiServerSource), err
}
